"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PersonalizationContainer = void 0;
var react_1 = __importDefault(require("react"));
var sdk_1 = require("@builder.io/sdk");
var react_2 = require("react");
var builder_blocks_component_1 = require("../components/builder-blocks.component");
var filter_with_custom_targeting_1 = require("../functions/filter-with-custom-targeting");
var attributeCookieName = 'builder.attributes';
function PersonalizationContainer(props) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t;
    var isBeingHydrated = Boolean(sdk_1.Builder.isBrowser && ((_a = window.__hydrated) === null || _a === void 0 ? void 0 : _a[(_b = props.builderBlock) === null || _b === void 0 ? void 0 : _b.id]));
    var _u = (0, react_2.useState)(isBeingHydrated), isClient = _u[0], setIsClient = _u[1];
    var _v = (0, react_2.useState)(0), update = _v[0], setUpdate = _v[1];
    (0, react_2.useEffect)(function () {
        setIsClient(true);
        var subscriber = sdk_1.builder.userAttributesChanged.subscribe(function () {
            sdk_1.builder.setCookie(attributeCookieName, JSON.stringify(sdk_1.builder.getUserAttributes()));
            setUpdate(update + 1);
        });
        return function () {
            subscriber.unsubscribe();
        };
    }, []);
    if (sdk_1.Builder.isServer) {
        react_1.default.createElement(react_1.default.Fragment, null, (_c = props.variants) === null || _c === void 0 ? void 0 :
            _c.map(function (variant, index) {
                var _a, _b;
                return (react_1.default.createElement("template", { key: index, "data-variant-id": ((_a = props.builderBlock) === null || _a === void 0 ? void 0 : _a.id) + index },
                    react_1.default.createElement(builder_blocks_component_1.BuilderBlocks, { blocks: variant.blocks, parentElementId: (_b = props.builderBlock) === null || _b === void 0 ? void 0 : _b.id, dataPath: "component.options.variants.".concat(index, ".blocks"), child: true })));
            }),
            react_1.default.createElement("script", { id: "variants-script-".concat((_d = props.builderBlock) === null || _d === void 0 ? void 0 : _d.id), dangerouslySetInnerHTML: { __html: getPersonalizationScript(props) } }),
            react_1.default.createElement("div", __assign({}, props.attributes, { "data-default-variant-id": (_e = props.builderBlock) === null || _e === void 0 ? void 0 : _e.id, className: "builder-personalization-container ".concat(props.attributes.className) }),
                react_1.default.createElement(builder_blocks_component_1.BuilderBlocks, { blocks: (_f = props.builderBlock) === null || _f === void 0 ? void 0 : _f.children, parentElementId: (_g = props.builderBlock) === null || _g === void 0 ? void 0 : _g.id, dataPath: "this.children", child: true })));
    }
    var filteredVariants = (props.variants || []).filter(function (variant) {
        return (0, filter_with_custom_targeting_1.filterWithCustomTargeting)(sdk_1.builder.getUserAttributes(), variant.query, variant.startDate, variant.endDate);
    });
    return (react_1.default.createElement("div", __assign({}, props.attributes, { style: __assign({ opacity: isClient ? 1 : 0, transition: 'opacity 0.2s ease-in-out' }, (_h = props.attributes) === null || _h === void 0 ? void 0 : _h.style), className: "builder-personalization-container ".concat(props.attributes.className, " ").concat(isClient ? '' : 'builder-personalization-container-loading') }),
        sdk_1.Builder.isEditing &&
            typeof props.previewingIndex === 'number' &&
            props.previewingIndex < (((_j = props.variants) === null || _j === void 0 ? void 0 : _j.length) || 0) ? (react_1.default.createElement(builder_blocks_component_1.BuilderBlocks, { blocks: (_l = (_k = props.variants) === null || _k === void 0 ? void 0 : _k[props.previewingIndex]) === null || _l === void 0 ? void 0 : _l.blocks, parentElementId: (_m = props.builderBlock) === null || _m === void 0 ? void 0 : _m.id, dataPath: "component.options.variants.".concat(props.previewingIndex, ".blocks"), child: true })) : // If editing the default or we're on the server and there are no matching variants show the default
            (sdk_1.Builder.isEditing && typeof props.previewingIndex !== 'number') ||
                !isClient ||
                !filteredVariants.length ? (react_1.default.createElement(builder_blocks_component_1.BuilderBlocks, { blocks: (_o = props.builderBlock) === null || _o === void 0 ? void 0 : _o.children, parentElementId: (_p = props.builderBlock) === null || _p === void 0 ? void 0 : _p.id, dataPath: "this.children", child: true })) : (
            // Show the variant matching the current user attributes
            react_1.default.createElement(builder_blocks_component_1.BuilderBlocks, { blocks: (_q = filteredVariants[0]) === null || _q === void 0 ? void 0 : _q.blocks, parentElementId: (_r = props.builderBlock) === null || _r === void 0 ? void 0 : _r.id, dataPath: "component.options.variants.".concat((_s = props.variants) === null || _s === void 0 ? void 0 : _s.indexOf(filteredVariants[0]), ".blocks"), child: true })),
        react_1.default.createElement("script", { dangerouslySetInnerHTML: {
                __html: "\n         window.__hydrated = window.__hydrated || {};\n         window.__hydrated['".concat((_t = props.builderBlock) === null || _t === void 0 ? void 0 : _t.id, "'] = true;\n        ").replace(/\s+/g, ' '),
            } })));
}
exports.PersonalizationContainer = PersonalizationContainer;
sdk_1.Builder.registerComponent(PersonalizationContainer, {
    name: 'PersonalizationContainer',
    noWrap: true,
    image: 'https://cdn.builder.io/api/v1/image/assets%2FYJIGb4i01jvw0SRdL5Bt%2F37229ed30d8c41dfb10b8cca1992053a',
    canHaveChildren: true,
    inputs: [
        {
            name: 'variants',
            defaultValue: [],
            behavior: 'personalizationVariantList',
            type: 'list',
            subFields: [
                {
                    name: 'name',
                    type: 'text',
                },
                {
                    name: 'query',
                    friendlyName: 'Targeting rules',
                    type: 'BuilderQuery',
                    defaultValue: [],
                },
                {
                    name: 'startDate',
                    type: 'date',
                },
                {
                    name: 'endDate',
                    type: 'date',
                },
                {
                    name: 'blocks',
                    type: 'UiBlocks',
                    hideFromUI: true,
                    defaultValue: [],
                },
            ],
        },
    ],
});
function getPersonalizationScript(props) {
    var _a, _b, _c, _d;
    return "\n      (function() {\n        function getCookie(name) {\n          var nameEQ = name + \"=\";\n          var ca = document.cookie.split(';');\n          for(var i=0;i < ca.length;i++) {\n              var c = ca[i];\n              while (c.charAt(0)==' ') c = c.substring(1,c.length);\n              if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);\n          }\n          return null;\n        }\n          function removeVariants() {\n            variants.forEach(function (template, index) {\n              document.querySelector('template[data-variant-id=\"' + \"".concat((_a = props.builderBlock) === null || _a === void 0 ? void 0 : _a.id, "\" + index + '\"]').remove();\n            });\n            document.getElementById('variants-script-").concat((_b = props.builderBlock) === null || _b === void 0 ? void 0 : _b.id, "').remove();\n          }\n\n        var attributes = JSON.parse(getCookie(\"").concat(attributeCookieName, "\") || \"{}\");\n        var variants = ").concat(JSON.stringify((_c = props.variants) === null || _c === void 0 ? void 0 : _c.map(function (v) { return ({ query: v.query, startDate: v.startDate, endDate: v.endDate }); })), ";\n        var winningVariantIndex = variants.findIndex(function(variant) {\n          return filterWithCustomTargeting(\n            attributes,\n            variant.query,\n            variant.startDate,\n            variant.endDate\n          );\n        });\n        if (winningVariantIndex !== -1) {\n          var winningVariant = document.querySelector('template[data-variant-index=\"' + \"").concat((_d = props.builderBlock) === null || _d === void 0 ? void 0 : _d.id, "\" + winningVariantIndex + '\"]');\n          if (winningVariant) {\n            var parentNode = winningVariant.parentNode;\n            var newParent = parentNode.cloneNode(false);\n            newParent.appendChild(winningVariant.content.firstChild);\n            parentNode.parentNode.replaceChild(newParent, parentNode);\n          }\n        } else if (variants.length > 0) {\n          removeVariants(); \n        }\n        function filterWithCustomTargeting(e,t,n,r){var i={query:t,startDate:n,endDate:r},o=e.date&&new Date(e.date)||new Date;return!(i.startDate&&new Date(i.startDate)>o)&&(!(i.endDate&&new Date(i.endDate)<o)&&(!i.query||!i.query.length||i.query.every((function(t){return objectMatchesQuery(e,t)}))))}function isString(e){return\"string\"==typeof e}function isNumber(e){return\"number\"==typeof e}function objectMatchesQuery(e,t){return function(){var n=t.property,r=t.operator,i=t.value;if(t&&\"urlPath\"===t.property&&t.value&&\"string\"==typeof t.value&&\"/\"!==t.value&&t.value.endsWith(\"/\")&&(i=t.value.slice(0,-1)),!n||!r)return!0;if(Array.isArray(i))return\"isNot\"===r?i.every((function(t){return objectMatchesQuery(e,{property:n,operator:r,value:t})})):!!i.find((function(t){return objectMatchesQuery(e,{property:n,operator:r,value:t})}));var o=e[n];if(Array.isArray(o))return o.includes(i);switch(r){case\"is\":return o===i;case\"isNot\":return o!==i;case\"contains\":return(isString(o)||Array.isArray(o))&&o.includes(String(i));case\"startsWith\":return isString(o)&&o.startsWith(String(i));case\"endsWith\":return isString(o)&&o.endsWith(String(i));case\"greaterThan\":return isNumber(o)&&isNumber(i)&&o>i;case\"lessThan\":return isNumber(o)&&isNumber(i)&&o<i;case\"greaterThanOrEqualTo\":return isNumber(o)&&isNumber(i)&&o>=i;case\"lessThanOrEqualTo\":return isNumber(o)&&isNumber(i)&&o<=i}return!1}()}\n      })();\n    ").replace(/\s+/g, ' ');
}
//# sourceMappingURL=PersonalizationContainer.js.map